module dc_trace

    use dc_types, only: token
    implicit none
    private

    logical, save         :: lfirst = .true.         ! ե饰
    integer, save, public :: dbg = -1                ! ֹ
    integer, save         :: level = 0               ! ֥롼٥
    integer, parameter    :: trace_stack_size = 128  ! 糬ؿ
    character(token), save:: table(trace_stack_size) ! آΥץ̾
    character(1), parameter :: head    = '#'         ! Ƭʸ
    character(2), parameter :: indent  = '| '        ! ʸ
    character(2), parameter :: meshead = '|-'        ! DbgMessage ѹƬʸ

    public:: BeginSub, EndSub, Debug, SetDebug, DbgMessage, Dbg_Scratch
    public:: SubLevel, DataDump

    interface DataDump
       module procedure DataD1Dump, DataD2Dump, DataD3Dump
    end interface

contains

    !-------------------------------------------------------
    ! ץγإ٥֤
    !-------------------------------------------------------
    integer function SubLevel() result(result)
        result = level
    end function SubLevel

    !-------------------------------------------------------
    ! ǥХåå
    !-------------------------------------------------------
    subroutine Dbg_Scratch(on)
        logical, intent(in):: on
        integer, save:: saved_dbg = -1
        logical:: x, p
        character(80):: line
        integer:: ios
    continue
        if (on) then
           if (dbg < 0) return
           saved_dbg = dbg
           ! ͭ 1  99 ֹ礭ͤ (?)
           dbg = 98
           do
              inquire(unit=dbg, exist=x, opened=p)
              ! ֹ dbg ³ǽǡ̤³ξ
              if (x .and. .not. p) then
                 ! ֹ deg 򥹥åեȤƳ
                 !    åեȤϡüʳեǤ롣
                 !      ̾ʤΰեǤꡢƤ
                 !      ֤¸ߤ롣Ĥޤꡢץबλ
                 !      ¸ߤʤʤ롣
                 open(unit=dbg, status='SCRATCH')
                 ! Фǽλ
                 return
              endif
              ! ֹ dbg ԲġޤѺѤξ 0 ʲ
              ! ʤޤ dbg - 1 Ʒ֤
              dbg = dbg - 1
              if (dbg < 0) exit
           enddo
           ! ֹ dbg ʤ硢dbg  saved_dbg 
           dbg = saved_dbg
           saved_dbg = -1
        else
           ! ֹ dbg = 980 ǥåե򳫤Ƥ
           ! ʤФǽλ
           if (saved_dbg < 0) return
           ! ֹ dbg ³줿åե򤽤γϰ
           ! ˰դ롣顼100 continueפ
           rewind(dbg, err=100)
           do
              ! ֹ dbg ³줿åեΰԤ
              ! line 
              read(dbg, '(A)', iostat=ios) line
              if (ios /= 0) exit
              ! line ֹ saved_dbg ؽ񤭽Ф
              write(saved_dbg, '(A)', iostat=ios) trim(line)
              if (ios /= 0) exit
           enddo
           100 continue
           close(dbg, iostat=ios)
           ! Ǹ dbg  saved_dbg 
           dbg = saved_dbg
           saved_dbg = -1
        endif
    end subroutine Dbg_Scratch

    !-------------------------------------------------------
    ! ǥХå⡼ɤ򥪥ˤ륵֥롼
    !-------------------------------------------------------
    subroutine SetDebug(debug)
        integer, intent(in), optional:: debug
        integer:: ios
        if (present(debug)) then
            ! debug ͿֹȤ deg Ѥ롣
            dbg = debug
            write(dbg, "(A, 'SetDebug: dbg =', i4)", iostat=ios) &
                 & trim(head), dbg
            if (ios == 0) return
        else
            ! debug Ϳ̵ֹ 0 (ɸ२顼)
            dbg = 0
            write(dbg, "(A, 'SetDebug: dbg = 0')", iostat=ios) trim(head)
            if (ios == 0) return
            ! ֹ 0 ؤνϤԤֹ 6 (ɸ)
            dbg = 6
            write(dbg, "(A, 'SetDebug: dbg = 6')", iostat=ios) trim(head)
            if (ios == 0) return
        endif
        ! 㳰Ȥ dbg ν
        dbg = -1
    end subroutine SetDebug

    !-------------------------------------------------------
    ! ǥХå⡼ɤɤο
    !-------------------------------------------------------
    logical function Debug() result(result)
        result = dbg >= 0
    end function Debug

    !-------------------------------------------------------
    ! 
    !-------------------------------------------------------
    subroutine initialize
        table(:) = ' '
        lfirst = .false.
    end subroutine initialize

    !-------------------------------------------------------
    ! ץ೫ϤΥå (level + 1)
    !-------------------------------------------------------
    subroutine BeginSub(name, fmt, i, r, d, L, s, n, c1, c2, c3)
        use dc_types, only: string
        use dcstring_base, only: vstring
        use dc_string, only: cprintf
        character(*), intent(in)          :: name
        character(*), intent(in), optional:: fmt
        integer,      intent(in), optional:: i(:), n(:)
        real,         intent(in), optional:: r(:)
        real(8),      intent(in), optional:: d(:)
        logical,      intent(in), optional:: L(:)
        type(vstring),intent(in), optional:: s(:)
        character(*), intent(in), optional:: c1, c2, c3
        character(string) :: cbuf
    continue
        if (lfirst) call initialize
        if (debug()) then
            if (present(fmt)) then
                cbuf = cprintf(fmt, i, r, d, L, s, n, c1, c2, c3)
                write(dbg, "(A, A, 'call ', A, ' : ', A)") trim(head), &
                    & repeat(indent, level), trim(name), trim(cbuf)
            else
                write(dbg, "(A, A, 'call ',A)") trim(head), & 
                    & repeat(indent, level), trim(name)
            endif
        endif
        ! call errtra ! --- for Fujitsu debug
        if (level > size(table)) return
        level = level + 1
        table(level) = name
    end subroutine BeginSub

    !-------------------------------------------------------
    ! ץཪλΥå (level - 1)
    !-------------------------------------------------------
    subroutine EndSub(name, fmt, i, r, d, L, s, n, c1, c2, c3)
        use dc_types, only: string
        use dcstring_base, only: vstring
        use dc_string, only: cprintf
        character(*), intent(in)          :: name
        character(*), intent(in), optional:: fmt
        integer,      intent(in), optional:: i(:), n(:)
        real,         intent(in), optional:: r(:)
        real(8),      intent(in), optional:: d(:)
        logical,      intent(in), optional:: L(:)
        type(vstring),intent(in), optional:: s(:)
        character(*), intent(in), optional:: c1, c2, c3
        character(string):: cbuf
    continue
        if (lfirst) call initialize
        ! call errtra ! --- for Fujitsu debug
        if (level <= 0) then
            write(*, "(A, 'Warning EndSub[',A,'] without BeginSub')") &
                & trim(head), trim(name)
        else if (name /= table(level)) then
            write(*, "(A, 'Warning EndSub[',A,'] but tos[',A,']')") &
                & trim(head), trim(name), trim(table(level))
        else
            level = level - 1
        endif
        if (debug()) then
            if (present(fmt)) then
                cbuf = cprintf(fmt, i, r, d, L, s, n, c1, c2, c3)
                write(dbg, "(A, A, 'end ', A, ' : ', A)") trim(head), &
                    & repeat(indent, level), trim(name), trim(cbuf)
            else
                write(dbg, "(A, A, 'end ', A)") trim(head), &
                    & repeat(indent, level), trim(name)
            endif
        endif
    end subroutine EndSub

    !-------------------------------------------------------
    ! å (level  0)
    !-------------------------------------------------------
    subroutine DbgMessage(fmt, i, r, d, L, s, n, c1, c2, c3)
        use dc_types, only: string
        use dcstring_base, only: vstring
        use dc_string, only: cprintf, toChar
        character(*), intent(in)          :: fmt
        integer,      intent(in), optional:: i(:), n(:)
        real,         intent(in), optional:: r(:)
        real(8),      intent(in), optional:: d(:)
        logical,      intent(in), optional:: L(:)
        type(vstring),intent(in), optional:: s(:)
        character(*), intent(in), optional:: c1, c2, c3
        character(string):: cbuf
        character(string):: meshead_tmp
        integer          :: meshead_len
    continue
        if (.not. debug()) return
        cbuf = cprintf(fmt, i, r, d, L, s, n, c1, c2, c3)
        if (level < 1) then
           meshead_tmp = ''
           meshead_len = 0
        else
           meshead_tmp = meshead
           meshead_len = len(meshead)
        endif
        write(dbg, "(A, A, A, A)") & 
             & trim(head), repeat( indent, max(level-1, 0) ), &
             & meshead_tmp(1:meshead_len), trim(cbuf)
    end subroutine DbgMessage


    !-------------------------------------------------------
    ! ¿ǡ (level  0)
    !-------------------------------------------------------
    subroutine DataD3Dump(header, d, strlen, multi)
      use dc_types,      only: string
      character(*), intent(in)          :: header  ! ǡ̾
      real(8),      intent(in)          :: d(:,:,:)! ټ¿ǡ
      integer,      intent(in), optional:: strlen  ! Ԥʸ
      integer,      intent(in), optional:: multi(:)! ̤μź

      integer, allocatable :: total(:)
      integer              :: k

    continue
      if (.not. debug()) return

      if (present(multi)) then
         allocate( total(size(multi)+1) )
         total(2:size(multi)+1) = multi(:)
      else
         allocate( total(1) )
      endif

      do k = 1, size( d(:,:,:), 3 )
         total(1) = k
         call DataDump(header, d(:,:,k), strlen=strlen, multi=total(:))
      enddo

      deallocate( total )

    end subroutine DataD3Dump

    subroutine DataD2Dump(header, d, strlen, multi)
      use dc_types,      only: string
      character(*), intent(in)          :: header  ! ǡ̾
      real(8),      intent(in)          :: d(:,:)  ! ټ¿ǡ
      integer,      intent(in), optional:: strlen  ! Ԥʸ
      integer,      intent(in), optional:: multi(:)! ̤μź

      integer, allocatable :: total(:)
      integer              :: j

    continue
      if (.not. debug()) return

      if (present(multi)) then
         allocate( total(size(multi)+1) )
         total(2:size(multi)+1) = multi(:)
      else
         allocate( total(1) )
      endif

      do j = 1, size( d(:,:), 2 )
         total(1) = j
         call DataDump(header, d(:,j), strlen=strlen, multi=total(:))
      enddo

      deallocate( total )

    end subroutine DataD2Dump

    subroutine DataD1Dump(header, d, strlen, multi)
      use dc_types,      only: string
      use dc_string,     only: toChar
      character(*), intent(in)          :: header  ! ǡ̾
      real(8),      intent(in)          :: d(:)    ! ټ¿ǡ
      integer,      intent(in), optional:: strlen  ! Ԥʸ
      integer,      intent(in), optional:: multi(:)! ̤μź

      integer          :: i, j

      character(string):: unit    ! ǡʸ
      character(string):: unitbuf ! ǡʸХåե
      integer          :: ucur    ! unit ˽񤫤줿ʸ
      character(string):: cbuf    ! read/write ʸΥХåե
      integer          :: stat    ! ơ

      logical  :: first  ! 1ܤΥǡɤ
      integer  :: begini ! 1ܤΥǡź
      integer  :: endi   ! ǸΥǡź

      character(string):: cmulti ! źʸ
      character(string):: cout   ! Ϥʸ

      character(string):: meshead_tmp
      integer          :: meshead_len
    continue
      if (.not. debug()) return

      ! 
      unit    = ''
      unitbuf = ''
      ucur    = 0
      stat    = 0
      first = .true.

      cmulti = ''

      ! ǥХååإåκ
      if (level < 1) then
         meshead_tmp = ''
         meshead_len = 0
      else
         meshead_tmp = meshead
         meshead_len = len(meshead)
      endif

      ! źʸ
      if (present(multi)) then
         do j = 1, size(multi)
            cmulti = trim(cmulti) // ', ' // trim(  toChar( multi(j) )  )
         enddo
      endif

      i = 1
      Dim_1_Loop : do
         if (first) begini = i
         endi = i
         write(cbuf, "(g40.20)") d(i)
         if (.not. first) cbuf = ', ' // adjustl(cbuf)
         unitbuf = unit
         call append(unit, ucur, trim(adjustl(cbuf)), stat, strlen)

         if ( stat /= 0 .or. i == size( d(:) ) ) then
            ! ܤϡʸСǤ⤽Τޤ޽ϡ
            if (first) then
               cout = header // '(' &
                    &   // trim(toChar(begini)) &
                    &   // trim(cmulti) &
                    &   // ')=' // trim(unit)
            ! ܰʹߤϡСΤϼ
            elseif (stat /= 0 .and. begini == endi-1) then
               cout = header // '(' &
                    &   // trim(toChar(begini)) &
                    &   // trim(cmulti) &
                    &   // ')='// trim(unitbuf)
               ! 1Ĵ᤹
               i = i - 1
            elseif (stat /= 0 .and. begini /= endi-1) then
               cout = header // '(' &
                    &   // trim(toChar(begini)) // '-' &
                    &   // trim(toChar(endi-1)) &
                    &   // trim(cmulti) &
                    &   // ')=' // trim(unitbuf)
               ! 1Ĵ᤹
               i = i - 1
            ! i  size(d) ޤã⤽Τޤ޽ϡ
            elseif ( i == size( d(:) ) ) then
               cout = header // '(' &
                    &   // trim(toChar(begini)) // '-' &
                    &   // trim(toChar(endi))   &
                    &   // trim(cmulti) &
                    &   // ')='// trim(unit)
            endif

            write(dbg, "(A, A, A, A)") & 
                 & trim(head), repeat( indent, max(level-1, 0) ), &
                 & meshead_tmp(1:meshead_len), trim(cout)

            ! unit, unitbuf 򥯥ꥢ
            unit    = ''
            unitbuf = ''
            ucur    = 0
            first = .true.
         else
            first = .false.
         endif
         if (i == size( d(:) ) ) exit Dim_1_Loop
         i = i + 1
      enddo Dim_1_Loop
    end subroutine DataD1Dump


    !
    ! ¼Ūˤ DataDump ؿ
    ! unit  val ղáκݡunit κʸĹۤ
    ! ˤ stat = 2 ֤
    !
    subroutine append(unit, ucur, val, stat, strlen)
      character(*), intent(inout):: unit ! ǽŪ֤ʸ
      integer,      intent(inout):: ucur ! unit ʸ
      character(*), intent(in)   :: val  ! unit ղäʸ
      integer,      intent(out)  :: stat ! ơ
      integer,      intent(in), &
           &        optional     :: strlen ! ʸμư

      integer                    :: wrsz ! val ʸ
      continue
      ! unit κĹۤˤ stat = 2 ֤
      if (present(strlen)) then
         if (ucur >= strlen) then
            stat = 2
            return
         endif
      else
         if (ucur >= len(unit)) then
            stat = 2
            return
         endif
      endif
      ! ν
      ! unit Ĺۤθ unit  val ղä롣
      wrsz = min(len(val), len(unit) - ucur)
      unit(1+ucur: wrsz+ucur) = val(1: wrsz)
      ucur = ucur + wrsz
      stat = 0
      if (wrsz < len(val)) stat = 1
    end subroutine append

end module
